=== src/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)
include(QuickLintJSCompiler)
include(QuickLintJSCopyright)
include(QuickLintJSTarget)

find_package(Threads REQUIRED)

if (QUICK_LINT_JS_ENABLE_CLI)
  set(EXTRA_SOURCES)
  if (WIN32)
    list(APPEND EXTRA_SOURCES quick-lint-js/cli/quick-lint-js.rc)
    # TODO(strager): Add a dependency on dusty-icon.ico which is referenced by
    # quick-lint-js.rc.
  endif ()
  quick_lint_js_add_executable(
    quick-lint-js
    quick-lint-js/cli/main.cpp
    ${EXTRA_SOURCES}
  )
  set_target_properties(quick-lint-js PROPERTIES RUNTIME_OUTPUT_DIRECTORY ..)
  target_link_libraries(quick-lint-js PRIVATE quick-lint-js-lib)
  quick_lint_js_enable_windows_unicode(quick-lint-js)

  # TODO(strager): Use the default DESTINATION for CMake versions which have a
  # default. (3.18.0 has a default; 3.12.4 doesn't have a default.)
  install(TARGETS quick-lint-js RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif ()

if (TARGET quick-lint-js-generate-diagnostic-metadata)
  add_custom_command(
    OUTPUT
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.h"
    COMMAND
      $<TARGET_FILE:quick-lint-js-generate-diagnostic-metadata>
      --output-info-cpp "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.cpp"
      --output-type-list-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-types-2.h"
    DEPENDS
      quick-lint-js-generate-diagnostic-metadata
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-types-2.h"
    COMMENT "Generating metadata of diagnostics for diagnostic-metadata-generated.h"
  )
endif ()
# NOTE[generated-target]: We must create a target just for these generated
# files. Otherwise, Ninja's build gets order-only dependencies from
# diagnostic-metadata-generated.h to libquick-lint-js-debug.a, forming a
# dependency cycle (because libquick-lint-js-debug.a depends on
# diagnostic-types.h which depends on diagnostic-metadata-generated.h).
#
# DEPENDS_EXPLICIT_ONLY (CMake 3.27) might fix this, removing the need for an
# intermediate target.
quick_lint_js_add_library(
  quick-lint-js-diagnostic-metadata
  STATIC
  quick-lint-js/diag/diagnostic-metadata-generated.cpp
  quick-lint-js/diag/diagnostic-metadata-generated.h
)
target_include_directories(quick-lint-js-diagnostic-metadata PUBLIC .)
target_link_libraries(
  quick-lint-js-diagnostic-metadata
  PUBLIC
  quick-lint-js-i18n
)
quick_lint_js_target_add_cxx_flag_if_supported(
  quick-lint-js-diagnostic-metadata
  /constexpr:steps9999999
  QUICK_LINT_JS_HAVE_CONSTEXPR_STEPS
)
quick_lint_js_target_add_cxx_flag_if_supported(
  quick-lint-js-diagnostic-metadata
  -fconstexpr-steps=9999999
  QUICK_LINT_JS_HAVE_FCONSTEXPR_STEPS
)

if (TARGET quick-lint-js-generate-lex-keyword)
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/fe/lex-keyword-generated.cpp"
    COMMAND
      $<TARGET_FILE:quick-lint-js-generate-lex-keyword>
      --output
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/fe/lex-keyword-generated.cpp"
    DEPENDS quick-lint-js-generate-lex-keyword
    COMMENT "Generating keyword hash table for lex-keyword-generated.cpp"
  )
endif ()

if (TARGET quick-lint-js-generate-trace-sources)
  add_custom_command(
    OUTPUT
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/debug/public/trace-generated.mjs"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-metadata-generated.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-writer-generated.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../tools/trace.bt"
    COMMAND
      $<TARGET_FILE:quick-lint-js-generate-trace-sources>
      --output-010-editor-template "${CMAKE_CURRENT_SOURCE_DIR}/../tools/trace.bt"
      --output-metadata-cpp "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-metadata-generated.cpp"
      --output-parser-cpp "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.cpp"
      --output-parser-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.h"
      --output-parser-js "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/debug/public/trace-generated.mjs"
      --output-writer-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-writer-generated.h"
      --trace-types-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-types.h"
    DEPENDS
      quick-lint-js-generate-trace-sources
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-types.h"
    COMMENT "Generating metadata files, parsers, and writers for tracing"
  )
endif ()
# See NOTE[generated-target].
quick_lint_js_add_library(
  quick-lint-js-trace
  STATIC
  quick-lint-js/logging/trace-metadata-generated.cpp
  quick-lint-js/logging/trace-reader-generated.cpp
  quick-lint-js/logging/trace-reader-generated.h
  quick-lint-js/logging/trace-writer-generated.h
)
target_include_directories(quick-lint-js-trace PUBLIC .)
target_link_libraries(quick-lint-js-trace PUBLIC quick-lint-js-tool-lib)

# C++ files which contain QLJS_TRANSLATABLE directives.
set(
  QLJS_TRANSLATION_SOURCES
  ../benchmark/benchmark-translation.cpp
  quick-lint-js/diag/diagnostic-formatter.cpp
  quick-lint-js/diag/diagnostic-metadata-generated.cpp
  quick-lint-js/diag/diagnostic-metadata-generated.h
  ../test/test-diagnostic-formatter.cpp
  ../test/test-vim-qflist-json-diag-reporter.cpp
)

# GNU gettext .po files which contain translation information.
set(
  QLJS_TRANSLATION_FILES
  ../po/de.po
  ../po/en_US@snarky.po
  ../po/fr_FR.po
  ../po/pt_BR.po
  ../po/sv_SE.po
)

if (TARGET quick-lint-js-compile-translations)
  set(COMMAND $<TARGET_FILE:quick-lint-js-compile-translations>)
  set(DEPENDS quick-lint-js-compile-translations)
  set(OUTPUTS)
  set(WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/..")

  macro (add_flag LIST FLAG PATH)
    # Make the output of compile-translations deterministic by using relative
    # paths.
    file(RELATIVE_PATH _PATH "${WORKING_DIRECTORY}" "${CMAKE_CURRENT_SOURCE_DIR}/${PATH}")
    list(APPEND COMMAND "${FLAG}" "${_PATH}")
    list(APPEND "${LIST}" "${CMAKE_CURRENT_SOURCE_DIR}/${PATH}")
  endmacro ()

  foreach (SOURCE IN LISTS QLJS_TRANSLATION_SOURCES)
    add_flag(DEPENDS --source "${SOURCE}")
  endforeach ()
  foreach (TRANSLATION_FILE IN LISTS QLJS_TRANSLATION_FILES)
    add_flag(DEPENDS --po "${TRANSLATION_FILE}")
  endforeach ()
  add_flag(OUTPUTS --output-messages-pot ../po/messages.pot)
  add_flag(OUTPUTS --output-translation-table-cpp quick-lint-js/i18n/translation-table-generated.cpp)
  add_flag(OUTPUTS --output-translation-table-h quick-lint-js/i18n/translation-table-generated.h)
  add_flag(OUTPUTS --output-translation-table-test quick-lint-js/i18n/translation-table-test-generated.h)

  add_custom_command(
    OUTPUT ${OUTPUTS}
    COMMAND ${COMMAND}
    DEPENDS ${DEPENDS}
    COMMENT "Scanning sources for translatable strings and generating translation tables"
    WORKING_DIRECTORY "${WORKING_DIRECTORY}"
  )
endif ()
# See NOTE[generated-target].
quick_lint_js_add_library(
  quick-lint-js-i18n
  STATIC
  quick-lint-js/i18n/translation-table-generated.cpp
  quick-lint-js/i18n/translation-table-generated.h
  quick-lint-js/i18n/translation-table-test-generated.h
)
target_include_directories(quick-lint-js-i18n PUBLIC .)

# These files are needed by some helper tools in addition to the core.
quick_lint_js_add_library(
  quick-lint-js-tool-lib
  quick-lint-js/assert.cpp
  quick-lint-js/assert.h
  quick-lint-js/cli/arg-parser.cpp
  quick-lint-js/cli/arg-parser.h
  quick-lint-js/cli/cli-location.cpp
  quick-lint-js/cli/cli-location.h
  quick-lint-js/container/flexible-array.h
  quick-lint-js/container/linked-bump-allocator.cpp
  quick-lint-js/container/linked-bump-allocator.h
  quick-lint-js/container/padded-string.cpp
  quick-lint-js/container/padded-string.h
  quick-lint-js/container/string-view.h
  quick-lint-js/container/vector-profiler.cpp
  quick-lint-js/container/vector-profiler.h
  quick-lint-js/container/vector.h
  quick-lint-js/container/winkable.h
  quick-lint-js/fe/keyword-lexer.h
  quick-lint-js/fe/keyword-list.h
  quick-lint-js/i18n/po-parser.cpp
  quick-lint-js/i18n/po-parser.h
  quick-lint-js/i18n/translation-table-compiler.cpp
  quick-lint-js/i18n/translation-table-compiler.h
  quick-lint-js/io/file-handle-posix.cpp
  quick-lint-js/io/file-handle-win32.cpp
  quick-lint-js/io/file-handle.h
  quick-lint-js/io/file-path.cpp
  quick-lint-js/io/file-path.h
  quick-lint-js/io/file.cpp
  quick-lint-js/io/file.h
  quick-lint-js/io/io-error.h
  quick-lint-js/io/output-stream.cpp
  quick-lint-js/io/output-stream.h
  quick-lint-js/port/char8.cpp
  quick-lint-js/port/char8.h
  quick-lint-js/port/have.h
  quick-lint-js/port/in-range.h
  quick-lint-js/port/limits.h
  quick-lint-js/port/math.h
  quick-lint-js/port/memory-resource.cpp
  quick-lint-js/port/memory-resource.h
  quick-lint-js/port/source-location.h
  quick-lint-js/port/thread.cpp
  quick-lint-js/port/thread.h
  quick-lint-js/port/type-traits.h
  quick-lint-js/port/warning.h
  quick-lint-js/port/windows-error.cpp
  quick-lint-js/port/windows-error.h
  quick-lint-js/port/windows.h
  quick-lint-js/reflection/cxx-parser.cpp
  quick-lint-js/reflection/cxx-parser.h
  quick-lint-js/util/cast.h
  quick-lint-js/util/enum.h
  quick-lint-js/util/float.cpp
  quick-lint-js/util/float.h
  quick-lint-js/util/integer.cpp
  quick-lint-js/util/integer.h
  quick-lint-js/util/utf-16.cpp
  quick-lint-js/util/utf-16.h
  quick-lint-js/util/utf-8.cpp
  quick-lint-js/util/utf-8.h
)
target_include_directories(quick-lint-js-tool-lib PUBLIC .)
if (WIN32)
  target_link_libraries(quick-lint-js-tool-lib PUBLIC pathcch)
endif ()

quick_lint_js_add_library(
  quick-lint-js-lib
  quick-lint-js/c-api-diag-reporter.cpp
  quick-lint-js/c-api-diag-reporter.h
  quick-lint-js/c-api.cpp
  quick-lint-js/c-api.h
  quick-lint-js/cli/emacs-lisp-diag-reporter.cpp
  quick-lint-js/cli/emacs-lisp-diag-reporter.h
  quick-lint-js/cli/emacs-location.cpp
  quick-lint-js/cli/emacs-location.h
  quick-lint-js/cli/options.cpp
  quick-lint-js/cli/options.h
  quick-lint-js/cli/text-diag-reporter.cpp
  quick-lint-js/cli/text-diag-reporter.h
  quick-lint-js/cli/vim-location.cpp
  quick-lint-js/cli/vim-location.h
  quick-lint-js/cli/vim-qflist-json-diag-reporter.cpp
  quick-lint-js/cli/vim-qflist-json-diag-reporter.h
  quick-lint-js/configuration/basic-configuration-filesystem.cpp
  quick-lint-js/configuration/basic-configuration-filesystem.h
  quick-lint-js/configuration/change-detecting-filesystem-inotify.cpp
  quick-lint-js/configuration/change-detecting-filesystem-kqueue.cpp
  quick-lint-js/configuration/change-detecting-filesystem-win32.cpp
  quick-lint-js/configuration/change-detecting-filesystem.cpp
  quick-lint-js/configuration/change-detecting-filesystem.h
  quick-lint-js/configuration/configuration-loader.cpp
  quick-lint-js/configuration/configuration-loader.h
  quick-lint-js/configuration/configuration.cpp
  quick-lint-js/configuration/configuration.h
  quick-lint-js/container/allocator.h
  quick-lint-js/container/async-byte-queue.cpp
  quick-lint-js/container/async-byte-queue.h
  quick-lint-js/container/byte-buffer.cpp
  quick-lint-js/container/byte-buffer.h
  quick-lint-js/container/c-string-list.h
  quick-lint-js/container/concat.h
  quick-lint-js/container/fixed-vector.h
  quick-lint-js/container/hash-map.h
  quick-lint-js/container/hash-set.h
  quick-lint-js/container/hash.h
  quick-lint-js/container/linked-vector.h
  quick-lint-js/container/optional.h
  quick-lint-js/container/result.h
