=== dist/debian/debian/changelog ===
quick-lint-js (3.2.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sun, 03 Mar 2024 23:36:12 -0500

quick-lint-js (3.1.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 10 Jan 2024 21:40:21 -0500

quick-lint-js (3.0.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 01 Jan 2024 02:11:59 -0500

quick-lint-js (2.19.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sat, 30 Dec 2023 01:40:27 -0500

quick-lint-js (2.18.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Fri, 03 Nov 2023 17:41:59 -0400

quick-lint-js (2.17.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 25 Oct 2023 19:42:44 -0400

quick-lint-js (2.16.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 06 Sep 2023 22:13:52 -0700

quick-lint-js (2.15.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 18 Jul 2023 18:58:52 -0700

quick-lint-js (2.14.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 22 May 2023 19:49:21 -0700

quick-lint-js (2.13.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 13 Apr 2023 16:33:56 -0700

quick-lint-js (2.12.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 08 Mar 2023 16:06:59 -0800

quick-lint-js (2.11.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 31 Jan 2023 16:27:10 -0800

quick-lint-js (2.10.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Fri, 14 Oct 2022 17:56:06 -0700

quick-lint-js (2.9.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 05 Sep 2022 18:02:20 -0700

quick-lint-js (2.8.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 25 Jul 2022 15:07:29 -0700

quick-lint-js (2.7.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 13 Jul 2022 14:32:01 -0700

quick-lint-js (2.6.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 15 Jun 2022 17:18:56 -0700

quick-lint-js (2.5.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 23 May 2022 14:22:17 -0700

quick-lint-js (2.4.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1009937)

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 27 Apr 2022 16:54:50 -0700
