=== dist/debian/debian/control ===
Source: quick-lint-js
Section: devel
Priority: optional
Maintainer: Matthew "strager" Glazar <strager.nds@gmail.com>
Build-Depends: debhelper (>= 12), cmake (>= 3.10), libgmock-dev, libgtest-dev, libsimdjson-dev, pkg-config
Standards-Version: 4.6.0.1
Homepage: https://quick-lint-js.com/
Vcs-Browser: https://github.com/quick-lint/quick-lint-js
Vcs-Git: https://github.com/quick-lint/quick-lint-js.git

Package: quick-lint-js
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JavaScript linter
 quick-lint-js finds bugs in your JavaScript code. This package includes the
 CLI and LSP server.

Package: quick-lint-js-vim
Architecture: all
Depends: ${misc:Depends}, quick-lint-js, vim, vim-addon-manager
Description: Vim and Neovim plugin for quick-lint-js
 quick-lint-js finds bugs in your JavaScript code. This plugin uses
 quick-lint-js to highlight errors in your editor.
