=== dist/debian/debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# HACK(strager): googletest was compiled without -fchar8_t (default for
# -std=c++20). It is missing symbols which might be referenced if quick-lint-js
# is built with -fchar8_t. Tell quick-lint-js' build system that -fchar8_t
# exists (QUICK_LINT_JS_HAVE_FCHAR8_T_FLAG=YES) but doesn't work
# (QUICK_LINT_JS_HAVE_WORKING_FCHAR8_T=NO), causing it to build with
# -fno-char8_t. This fixes undefined symbol errors when linking tests.
override_dh_auto_configure:
	dh_auto_configure -- \
		-DQUICK_LINT_JS_HAVE_FCHAR8_T_FLAG=YES \
		-DQUICK_LINT_JS_HAVE_WORKING_FCHAR8_T=NO \
		-DQUICK_LINT_JS_INSTALL_EMACS_DIR=share/emacs/site-lisp/quick-lint-js \
		-DQUICK_LINT_JS_INSTALL_VIM_DIR=share/vim/addons \
		-DQUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS=ON \
		-DQUICK_LINT_JS_USE_BUNDLED_GOOGLE_BENCHMARK=NO \
		-DQUICK_LINT_JS_USE_BUNDLED_GOOGLE_TEST=NO \
		-DQUICK_LINT_JS_USE_BUNDLED_SIMDJSON=NO \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=YES

override_dh_auto_install:
	dh_auto_install
	install -m644 -D \
		plugin/vim/quick-lint-js.yaml \
		debian/tmp/usr/share/vim/registry/quick-lint-js.yaml
